<!-- layouts/default.vue -->

<template>
  <!-- <Toast :visible="toastVisible" :title="toastTitle" :message="toastMessage" /> -->
  <NuxtLayout :name="'dashboard'">
    <CardList @on-click="onClick" :items="cards" />
  </NuxtLayout>
</template>

<script lang="ts">
import axios from "axios";

definePageMeta({
  middleware: ["auth"],
});

export default {
  middleware: ["auth"],
  data() {
    return {
      toastVisible: false,
      toastTitle: "",
      toastMessage: "",
      cards: [{}],
    };
  },
  mounted() {
    this.fetchData();
  },
  methods: {
    fetchData() {
      const config = useRuntimeConfig();
      this.$api
        .get(`/file/`, {
          headers: {
            Authorization: `Bearer ${localStorage.getItem("access_token")}`,
            Accept: 'application/json'
          },
        })
        .then((response) => {
          let datas = response.data;
          console.log(datas)
          datas.map((item: any) => {
            item.owner_name = item.owner.name;
            item.owner_email = item.owner.email;
            delete item.owner;
            item.action = [
              {
                icon: "material-symbols:edit-outline",
                color: "bg-blue-500",
                route: `/upload/${item.id}`,
                disabled: false
              },
              {
                icon: "material-symbols:cloud-download-outline-rounded",
                color: "bg-green-500",
                route: `/files/${item.id}`,
                disabled: item.file_path ? false : true
              },
              {
                icon: "material-symbols:delete-outline-rounded",
                color: "bg-red-500",
                disabled: false,
                callback: 'delete-file',
              },
            ];
            const filepath = item.file_path ? item.file_path : ''
            delete item.file_path;
            item.file_path = filepath
          });
          this.cards = datas;
          console.log(datas)
        })
        .catch((error) => {
          console.log(error);
          const detail = error.response.data.detail;
          let message = "";
          if (detail[0].msg) {
            message = detail[0].msg;
          } else {
            message = detail;
          }
          this.showToast("error", message);
        });
    },
    async onClick(item: any) {
      const toastStore = useToastStore();
      try {
        const response = await this.$api.get(`/file/download/${item.id}`, {
          headers: {
            Authorization: `Bearer ${localStorage.getItem('access_token')}`,
          },
          responseType: 'blob', // Important to handle binary data like a PDF
        });

        const url = window.URL.createObjectURL(new Blob([response.data]));
        const link = document.createElement('a');
        link.href = url;
        link.setAttribute('download', 'downloaded_file.pdf');
        document.body.appendChild(link);
        link.click();
        document.body.removeChild(link);
      } catch (error: any) {
        console.error('Error downloading PDF:', error);
        if (error.response.status == 404)
          toastStore.showToast('File tidak ditemukan!', 'danger');
        else
          toastStore.showToast(error.response.data.detail, 'danger');
      }
    },
    showToast(title: string, message: string) {
      this.toastTitle = title;
      this.toastMessage = message;
      this.toastVisible = true;
      setTimeout(() => {
        this.toastVisible = false;
      }, 2000);
    },
  },
};
</script>
